## f_mkfs

The f_mkfs fucntion creates an FAT file system on the logical drive.

    FRESULT f_mkfs (
      const TCHAR* path,  /* [IN] Logical drive number */
      BYTE  sfd,          /* [IN] Partitioning rule */
      UINT  au            /* [IN] Size of the allocation unit */
    );

#### Parameters

path
  Pinter to the null-terminated string that specifies the logical drive to be formatted. If there is no drive number, it means the default drive.
sfd
  Specifies partitioning rule (FDISK(0) or SFD(1)). This argument will be ignored on some case.
au
  Specifies size of the allocation unit (cluter) in unit of byte. The value must be sector size * n (n is 1 to 128 and power of 2). When a zero is given, the cluster size is determined depends on the volume size.

#### Return Values

FR_OK, FR_DISK_ERR, FR_NOT_READY, FR_WRITE_PROTECTED, FR_INVALID_DRIVE, FR_NOT_ENABLED, FR_MKFS_ABORTED, FR_INVALID_PARAMETER

#### Description

The `f_mkfs()` function creates an FAT volume on the logical drive. When FDISK format is specified, a primary partition occupies the entire disk space is created and then an FAT volume is created on the partition. When SFD format is specified, the FAT volume starts from the first sector of the physical drive.

If the logical drive has been bound to any partition (1-4) by multiple partition feature (`_MULTI_PARTITION`), the FAT volume is created into the specified partition. In this case, the second argument `sfd` is ignored. The physical drive must have been partitioned with `f_fdisk()` function or any other partitioning tool prior to use this function.

Note that there are two partitioning rules, FDISK and SFD. The FDISK partitioning is usually used for harddisk, MMC, SDC, CFC and U Disk. It can divide a physical drive into one or more partitions with a partition table on the MBR. However Windows does not support multiple partition on the removable media. The SFD is non-partitioned method. The FAT volume starts from the first sector on the physical drive without partition table. It is usually used for floppy disk, Microdrive, optical disk and super-floppy media.

The FAT sub-type, FAT12/FAT16/FAT32, is determined by number of clusters on the volume and nothing else, according to the FAT specification issued by Microsoft. Thus which FAT sub-type is selected, is depends on the volume size and the specified cluster size. The cluster size affects performance of the file system and large cluster increases the performance.

When the number of clusters gets near the FAT sub-type boundaries, the function can fail with `FR_MKFS_ABORTED`.

#### QuickInfo

Available when `_FS_READOLNY == 0` and `_USE_MKFS == 1`.

#### See Also

`Volume management, f_fdisk`

Return